
#include "opensshdviewitems.h"


PUBLIC int OPENSSHD_VIEWITEMS::write (CONFIG_FILE &fconf, PRIVILEGE *priv)
{
	int ret = -1;
	FILE *fout = fconf.fopen (priv,"w");
	if (fout != NULL){
		int n = getnb();
		comment_write (firstcomment,fout);
		for (int i=0; i<n; i++){
			VIEWITEM *it = getitem (i);
			comment_write (it->comment,fout);
			if (!it->line.is_empty()){
				fprintf (fout,"%s%s\n",it->line.get(),it->endcomment.get());
			}
		}
		comment_write (lastcomment,fout);
		ret = fclose (fout);
	}
	return ret;
}

PUBLIC const char *OPENSSHD_VIEWITEMS::locateval (const char *var)
{
	const char *ret = NULL;
	VIEWITEM *it = locate(var);
	if (it != NULL){
		ret = it->line.get();
		ret = str_skip(ret);
		ret += strlen(var);
		ret = str_skip(ret);
	}
	return ret;
}


PUBLIC void OPENSSHD_VIEWITEMS::update (
	const char *var,
	const char *val)
{
	VIEWITEM *it = locate(var);
	if (it == NULL){
		it = new VIEWITEM("");
		add (it);
	}
	char buf[1000];
	snprintf (buf,sizeof(buf)-1,"%s %s",var,val);
	it->line.setfrom (buf);
}

PUBLIC void OPENSSHD_VIEWITEMS::clear (const char *var)
{
	VIEWITEM *it = locate(var);
	if (it != NULL){
		it->line = "";
	}
}

// vim: nowrap

