/*
 Printer configurator for Linuxconf v1.1
 (1.0 released on 1.18r5)
 by Daniel Mealha Cabrita (dancab@iname.com)
 June 1st, 2000
*/

/*
 this module needs:
 rhs-printfilters-1.57-3cl (used by or part of RH's printtool)
 because the /usr/lib/rhs/rhs-printfilters/ files
*/

/*
 look at
 printer_common_data.*
 for defines' table
*/

/*
 module features:
 - edit/add/remove printers and their filter configuration
 - manages hosts allowed to access local queues
 - manages printers' queues
 - detects if lpd is being started automatically for current
   runlevel and, if it isn't and user confirms action,
   configures lpd for starting automatically
 - fills gui fields with common/default values so the user doesn't
   need to provide data (s)he doesn't know or gives hint ofwhat
   kind of data he must provide
*/


/* ***********

	Check comments starting with // ### and fill appropriate code there

   ***********
*/
#pragma implementation
#include <stdio.h>
#include <string.h>
#include <translat.h>
#include "printer.h"
#include "printer.m"

MODULE_DEFINE_VERSION(printer);

PUBLIC MODULE_printer::MODULE_printer()
	: LINUXCONF_MODULE("printer")
{
	linuxconf_loadmsg ("printer",PACKAGE_REV);
}


static const char *keymenu=NULL;

PUBLIC void MODULE_printer::setmenu (
	DIALOG &dia,
	MENU_CONTEXT context)
{
	if (context == MENU_MISCSERV){
		keymenu = MSG_U(M_printer,"Printer");
		dia.new_menuitem ("printer","",keymenu);
	}
}

PUBLIC int MODULE_printer::domenu (
	MENU_CONTEXT context,
	const char *key)
{
	if (context == MENU_MISCSERV){
		if (key == keymenu){

                    printer_ed();
                    // ### Place the call to the edit function here
		}
	}
	return 0;
}


PUBLIC int MODULE_printer::dohtml (const char *key)
{
	int ret = LNCF_NOT_APPLICABLE;
	if (strcmp(key,"printer")==0){
		// ### Insert any menu and dialog here
		ret = 0;
	}
	return ret;
}


static void usage()
{
    xconf_error (MSG_U(T_USAGE
		,"linuxconf --modulemain printer usage\n"
		 "\n"
		 "    printer --option ...\n")
		);
}

PUBLIC void MODULE_printer::usage (SSTRINGS &tb)
{
	tb.add (new SSTRING (MSG_R(T_USAGE)));
}

PUBLIC int MODULE_printer::execmain (int argc , char *argv[])
{
	int ret = LNCF_NOT_APPLICABLE;
	const char *pt = strrchr(argv[0],'/');
	if (pt != NULL){
		pt++;
	}else{
		pt = argv[0];
	}

        if (strcmp(pt,"printer")==0){
            ret = -1;
                if (argc == 1){
                    // ### Place call to main menu of the module
                    printer_ed();
                }else{
                    // ### Add some option parsing for the module
			::usage();
		}
	}
	return ret;
}


PUBLIC int MODULE_printer::probe(int level, int target, bool simul)
{
/*    printf("------\n");
    printf("level: %d\ntarget: %d\n", level, target);

    if(simul==true){
        printf("simul==true\n");
    } else {
        printf("simul==false\n");
    }
*/
    return(0);
}


static MODULE_printer printer;

