#include <sys/types.h>
#include <dirent.h>
#include <popen.h>
#include "tlmplib.h"

bool _F_walkfs::recurse(const char *)
{
	return true;
}


int walkfs (_F_walkfs &c, const char *dirpath)
{
	int ret = -1;
	DIR *dir = opendir (dirpath);
	if (dir != NULL){
		ret = 0;
		struct dirent *ent;
		while ((ent = readdir (dir)) != NULL){
			if (strcmp(ent->d_name,".")!=0
				&& strcmp(ent->d_name,"..")!=0){
				char path[PATH_MAX];
				snprintf (path,sizeof(path)-1,"%s/%s",dirpath,ent->d_name);
				c.onefile (path);
				if (file_type(path)==1
					&& c.recurse(path)){
					// This is a directory and we are allowed to recurse
					ret += walkfs (c,path);
				}
				ret ++;
			}
		}
		closedir (dir);
	}
	return ret;
}

int _F_walkpopen::oneerr(const char *)
{
	return 0;
}

static int walkpopen_common (
	_F_walkpopen &c,
	POPEN &pop,
	int timeout)
{
	int ret = -1;
	if (pop.isok()){
		ret = 0;
		while (1){
			if (pop.wait(timeout)< 0) break;
			char buf[PATH_MAX];
			while (pop.readout(buf,sizeof(buf))!=-1){
				int last = strlen(buf) - 1;
				if (last >= 0 && buf[last] == '\n') buf[last] = '\0';
				if (c.oneline (buf)==-1){
					ret = -1;
					break;
				}
				ret ++;
			}
			while (pop.readerr(buf,sizeof(buf))!=-1){
				int last = strlen(buf) - 1;
				if (last >= 0 && buf[last] == '\n') buf[last] = '\0';
				if (c.oneerr (buf)==-1){
					ret = -1;
					break;
				}
			}
		}
	}
	return ret;

}

int walkpopen (
	_F_walkpopen &c,
	const char *command,
	int timeout)
{
	POPEN pop (command);
	return walkpopen_common (c,pop,timeout);
}
int walkpopen (
	_F_walkpopen &c,
	const char *command,
	const char *arg,
	int timeout)
{
	POPEN pop (command,arg);
	return walkpopen_common (c,pop,timeout);
}

